"use strict";

module.exports = function find(iterable, predicate) {
	if (Array.isArray(iterable)) {
		// An optimized implementation may be available
		return iterable.find(predicate);
	} else {
		let i = 0;

		for (let value of iterable) {
			let found = predicate(value, i, iterable);

			if (found) {
				return value;
			}

			i++;
		}
	}
};
