"use strict";

// Kinda like `find`, but the ?? edition - evaluates items until one produces a not-nullish result

module.exports = function firstValue(iterable, predicate) {
	let i = 0;

	for (let value of iterable) {
		let found = predicate(value, i, iterable);

		if (found != null) {
			return found;
		}

		i++;
	}
};
