"use strict";

// TODO: Add concurrency control?

const map = require("../map");

module.exports = async function mapAsync(iterable, mapper, options = {}) {
	let concurrent = options.concurrent ?? true;

	if (concurrent) {
		return Promise.all(map(iterable, mapper));
	} else {
		let results = [];
		let i = 0;

		for (let value of iterable) {
			let result = await mapper(value, i, iterable);
			results.push(result);
		}

		return results;
	}
};
