"use strict";

// FIXME: Untested

const isIterable = require("is-iterable");
const forEach = require("../for-each");

module.exports = function treeFilterFlat(tree, filter, options = {}) {
	let key = options.key ?? "children";
	let recurseFilteredSubtrees = options.recurseFilteredSubtrees ?? false;

	let results = [];

	function step(subtree) {
		let matchesFilter = filter(subtree);

		if (matchesFilter || recurseFilteredSubtrees) {
			if (isIterable(subtree[key])) {
				for (let item of subtree[key]) {
					step(item);
				}
			} else if (subtree[key] != null && typeof subtree[key] === "object") {
				step(subtree[key]);
			}
		}

		if (matchesFilter) {
			results.push(subtree);
		}
	}

	if (isIterable(tree)) {
		forEach(tree, step);
	} else {
		step(tree);
	}

	return results;
};
